function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

// react
import React from "react";
import PropTypes from "prop-types"; // kendo component

import { DateTimePicker } from '@progress/kendo-react-dateinputs'; // other

import moment from 'moment';
const Style = {
  datePicker: {}
};

class FeeDateTimePicker extends React.Component {
  constructor(...args) {
    super(...args);
    this.state = {
      value: null
    };

    this.handleChange = event => {
      // disabled 時 , 將 DatePicker 上鎖 , 不做 handleChange
      if (this.props.disabled) return;
      const date = event.value;
      const newValue = {
        code: moment(date).format('YYYYMMDD HH:mm:SS'),
        show: moment(date).format('YYYY/MM/DD HH:mm:SS'),
        origin: date
      }; // const newEvent = {target: {value: date}};

      this.props.onChange && this.props.onChange(event, newValue);
      this.setState({
        value: date
      });
    };
  }

  componentWillMount() {
    this.setState({
      value: this.props.defaultValue
    });
  }

  render() {
    return React.createElement(DateTimePicker, _extends({}, this.props, {
      width: '90%',
      style: Style.datePicker,
      value: this.state.value,
      format: "yyyy/MM/dd",
      validationMessage: "\u8ACB\u8F38\u5165\u6B63\u78BA\u7684\u6642\u9593\u683C\u5F0F",
      onChange: this.handleChange
    }));
  }

}

FeeDateTimePicker.propTypes = {
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.instanceOf(Date)]),
  onChange: PropTypes.func.isRequired
};
export default FeeDateTimePicker;